#import "@preview/tidy:0.4.0"

#import "src/lib.typ"

#import "gallery/readme_banner.typ" as banner

#set text(font: "Source Sans 3")
#set page(
  header: [
    jumble #sym.dash.em v#lib.version
  ],
  footer: context {
    if counter(page).get().first() != 1 {
      align(center, counter(page).display("1 / 1", both: true))
    }
  }
)

#align(center)[
  #v(1cm)
  #text(size: 2em)[
    *#banner.txt*
  ]

  #text(size: 1.5em)[
    #banner.colorize-hex(banner.cipher)
  ]
  
  #v(0.5cm)

  _by LordBaryhobal_

  #v(3cm)

  #text(
    size: 1.8em
  )[
    *Manual*
  ]

]

#v(1fr)

#box(
  width: 100%,
  stroke: black,
  inset: 1em,
  outline(
    indent: 1em,
    target: heading.where(level: 2)
  )
)


#pagebreak(weak: true)

#let mod = tidy.parse-module.with(
  scope: (jumble: lib),
  preamble: "#import jumble: *;"
)

#let sha-doc = mod(
  read("src/sha.typ"),
  name: "sha"
)
#tidy.show-module(sha-doc)

#pagebreak(weak: true)

#let md-doc = mod(
  read("src/md.typ"),
  name: "md"
)
#tidy.show-module(md-doc)

#pagebreak(weak: true)

#let misc-doc = mod(
  read("src/misc.typ"),
  name: "misc"
)
#tidy.show-module(misc-doc)

#pagebreak(weak: true)

#let base-doc = mod(
  read("src/base.typ"),
  name: "base"
)
#tidy.show-module(base-doc)

#pagebreak(weak: true)

#let utils-doc = mod(
  read("src/utils.typ"),
  name: "utils"
)
#tidy.show-module(utils-doc)